function y = admean(x,dim)


% ignore NaNs and Infs
if nargin<2
    dim = find(size(x)>1,1,'first');
    if isempty(dim)
        dim = 1;
    end
end

inds = isfinite(x);
denom = sum(inds,dim);
x(~inds) = 0;
num = sum(x,dim);

y = num./denom;

if isempty(y)
    y = NaN; % to preserve previous functionality
end