function ordim = adordfilt(im,nhood,ordfrac)

if nargin<3 || isempty(ordfrac)
    ordfrac = 0.5;
end

if nargin<2 || isempty(nhood)
    nhood = discel(5,1);
end

ordim = zeros(size(im));

for ii = 1:size(im,3)
    ordim(:,:,ii) = ordfilt2(im(:,:,ii),ceil(ordfrac*nnz(nhood)),nhood,'symmetric');
end