function fim = ordfiltz(im,wsiz,ord)

% order statistic filtering in the z direction

if nargin<3 || isempty(ord)
    ord = 0.5; % median filtering
end

% first reshape the array into 2D
im2d = reshape(im,[size(im,1)*size(im,2),size(im,3)]);

nhood = ones(1,wsiz);

fim2d = ordfilt2(im2d,ceil(wsiz*ord),nhood,'symmetric');

fim = reshape(fim2d,size(im));