function Lout = rescalelabels(Lin)

% rescale the label array so that there are no gaps in the numbers, useful
% for if you've merged non touching objects after using bwlabel, or if some
% objects have been removed using regionprops criteria.

lvals = unique(Lin(Lin>0));

Lout = zeros(size(Lin));

for ii = 1:numel(lvals)
    Lout(Lin==lvals(ii)) = ii;
end

