function [imout,imy] = sobel2(imin, thresh, thin)

if isa(imin,'integer')
	imin = double(imin);
end

if nargin<3
	if nargin<2 || isempty(thresh)
		thresh = 0;
	end
	thin = 0;
end

sx = [3 0 -3;...    % = [3
     10 0 -10;...   %    10 * [1 0 -1]
      3 0 -3];      %    3]
sy = sx';

sx1 = [3;10;3];
sx2 = [1,0,-1];

sy1 = [1;0;-1];
sy2 = [3 10 3];

% size(imin)
% try
%     impad = zeros(size(imin) + [4 4]);
%     impad(3:(end-2),3:(end-2)) = imin;
%     impad([1,2,(end-1),end],3:(end-2)) = imin([2,1,end,(end-1)],:);
%     impad(:,[1,2,(end-1),end]) = impad(:,[4,3,(end-2),(end-3)]);
% catch ME
%     rethrow(ME)
% end

% impad = padarray(imin,[2 2],'replicate');

% if length(size(imin))==2
%     imx = conv2(impad,sx,'same');
%     imy = conv2(impad,sy,'same');
% else
%     imx = convn(impad,sx,'same');
%     imy = convn(impad,sy,'same');
% end

imx = imfilter(imfilter(imin,sx1,'replicate','same'),sx2,'replicate','same');
imy = imfilter(imfilter(imin,sy1,'replicate','same'),sy2,'replicate','same');


% imx = imx(3:(end-2),3:(end-2));
% imy = imy(3:(end-2),3:(end-2));

if nargout==1
    if thin
        imout = nonmaxsupp2(imx,imy,thresh);
    elseif thresh==0
        imout = sqrt(imx.^2 + imy.^2);
    else
        imout = (imx.^2 + imy.^2)>(thresh^2);
    end
else
    imout = imx;
end
