function [zim,stdim,mim] = zfilt(im,nhood)

% filter an image, giving the number of standard deviations a pixel is from
% the mean of its neighbourhood.

% calculate stdev by mean(square) - square(mean)

% mim = conv2(im,double(nhood)/nnz(nhood),'same');
mim = imfilter(im,double(nhood),'symmetric')/nnz(nhood);

% mim2 = conv2(im.^2,double(nhood)/nnz(nhood),'same');

% stdim = sqrt((mim2 - (mim.^2))/(nnz(nhood)));
stdim = stdfilt(im,nhood);

zim = (im - mim)./stdim;