function nim = znorm(im,minrange)

if nargin<2 || isempty(minrange)
    minrange = 0.3;
end

if minrange<1
    
    imstd = adstd(im(:));
    if imstd>1
        % most likely we've specified the minrange as a fraction of the image
        % std
        minrange = minrange*imstd;
    end
end

minim = min(im,[],3);
maxim = max(im,[],3);

numim = repmath(im,minim,'-');
denomim = max(minrange,maxim-minim);

nim = repmath(numim,denomim,'/');